'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _ValidstateConst = require('./ValidstateConst');

var ValidstateConst = _interopRequireWildcard(_ValidstateConst);

var _ValidstateMessages = require('./ValidstateMessages');

var _ValidstateMessages2 = _interopRequireDefault(_ValidstateMessages);

var _lodash = require('lodash.clonedeep');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Validstate = function () {

  /*
  * @function constructor
  * @description Initilize component variables
  * @param
  * @returns Validstate instance
  */
  function Validstate() {
    _classCallCheck(this, Validstate);

    this.store = null;
    this.validationConfig = {};
    this.validations = [];
    this.properties = {};
    this.initialProperties = {};
    this.messages = {};
    this.messageTemplate = new _ValidstateMessages2.default();
    this.requireGroups = [];
  }

  /*
  * @function init
  * @description Initilize object with application rules
  * @param rules, store
  * @returns Validstate instance
  */


  _createClass(Validstate, [{
    key: 'init',
    value: function init(validationConfig, store) {
      this.validationConfig = validationConfig;
      this.store = store;

      //Parse validations for properties
      this.extract();

      this.initialProperties = (0, _lodash2.default)(this.properties);

      this.store.dispatch({
        type: ValidstateConst.VALIDSTATE_INIT,
        payload: this.properties
      });
    }

    /*
    * @function extract
    * @description Extract Properties, validations and requireGroups from rules
    * @param
    * @returns Properties object
    */

  }, {
    key: 'extract',
    value: function extract() {
      this.properties = {
        valid: null
      };

      // Sets validations
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = Object.entries(this.validationConfig)[Symbol.iterator](), _step2; !(_iteratorNormalCompletion = (_step2 = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var _step2$value = _slicedToArray(_step2.value, 2),
              validationKey = _step2$value[0],
              validation = _step2$value[1];

          if (this.validations.includes(validationKey)) {
            throw new Error('Duplicate validation key. ' + validationKey + ' was already used.');
          } else {
            this.validations.push(validationKey);
          }

          this.properties[validationKey] = {
            valid: null
          };

          // Sets top level properties
          var _iteratorNormalCompletion2 = true;
          var _didIteratorError2 = false;
          var _iteratorError2 = undefined;

          try {
            for (var _iterator2 = Object.entries(validation)[Symbol.iterator](), _step3; !(_iteratorNormalCompletion2 = (_step3 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
              var _step3$value = _slicedToArray(_step3.value, 2),
                  propertyKey = _step3$value[0],
                  property = _step3$value[1];

              if (propertyKey === "_messages") {
                // Messages Property
                if (!this.thetypeof(this.messages[validationKey]).is('object')) {
                  this.messages[validationKey] = {};
                }

                this.messages[validationKey] = property;
              } else if (Object.keys(property)[0] == "forEach") {
                this.properties[validationKey][propertyKey] = {
                  valid: null,
                  elements: []
                };
              } else {
                // Checks for nested properties
                if (this.depthOf(property) > 1) {
                  this.properties[validationKey][propertyKey] = this.extractObj(property);
                } else {
                  this.properties[validationKey][propertyKey] = {
                    valid: null,
                    reason: null,
                    message: null
                  };
                }
              }
            }
          } catch (err) {
            _didIteratorError2 = true;
            _iteratorError2 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion2 && _iterator2.return) {
                _iterator2.return();
              }
            } finally {
              if (_didIteratorError2) {
                throw _iteratorError2;
              }
            }
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }
    }

    /*
    * @function extractObj
    * @description extracts objects from supplied properties
    * @param property
    * @returns object
    */

  }, {
    key: 'extractObj',
    value: function extractObj(property) {
      var initialValues = {
        valid: null,
        reason: null,
        message: null
      };

      var _iteratorNormalCompletion3 = true;
      var _didIteratorError3 = false;
      var _iteratorError3 = undefined;

      try {
        for (var _iterator3 = Object.entries(property)[Symbol.iterator](), _step4; !(_iteratorNormalCompletion3 = (_step4 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
          var _step4$value = _slicedToArray(_step4.value, 2),
              propertyKey = _step4$value[0],
              nextProp = _step4$value[1];

          if (propertyKey === "_reducer") {
            continue;
          } else if (this.depthOf(nextProp) > 1) {
            initialValues[propertyKey] = this.extractObj(nextProp);
          } else {
            initialValues[propertyKey] = {
              valid: null,
              reason: null,
              message: null
            };
          }
        }
      } catch (err) {
        _didIteratorError3 = true;
        _iteratorError3 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion3 && _iterator3.return) {
            _iterator3.return();
          }
        } finally {
          if (_didIteratorError3) {
            throw _iteratorError3;
          }
        }
      }

      return initialValues;
    }

    /*
    * @function validate
    * @description Run specified validations
    * @param validation
    * @returns boolean
    */

  }, {
    key: 'validate',
    value: function validate(validation) {
      if (this.validationConfig[validation] == undefined) {
        throw new Error(validation + ' validation does not exist.');
        return false;
      }

      var mergedState = this.mergeState(this.store.getState());

      this.properties[validation].valid = true;

      var _iteratorNormalCompletion4 = true;
      var _didIteratorError4 = false;
      var _iteratorError4 = undefined;

      try {
        for (var _iterator4 = Object.entries(this.validationConfig[validation])[Symbol.iterator](), _step5; !(_iteratorNormalCompletion4 = (_step5 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
          var _step5$value = _slicedToArray(_step5.value, 2),
              propertyKey = _step5$value[0],
              property = _step5$value[1];

          if (propertyKey == "_messages") {
            continue;
          } else if (propertyKey == "_reducer") {
            continue;
          } else {
            var propertyValidstate = {
              valid: true,
              reason: null,
              message: null
              // Check top level property has children
            };if (this.depthOf(property) > 1) {
              propertyValidstate = this.validateNestedProperties(property, mergedState[propertyKey]);
              if (propertyValidstate.valid == false) {
                this.properties[validation].valid = false;
              }
            } else {
              var _iteratorNormalCompletion5 = true;
              var _didIteratorError5 = false;
              var _iteratorError5 = undefined;

              try {
                for (var _iterator5 = Object.entries(property)[Symbol.iterator](), _step6; !(_iteratorNormalCompletion5 = (_step6 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
                  var _step6$value = _slicedToArray(_step6.value, 2),
                      ruleKey = _step6$value[0],
                      rule = _step6$value[1];

                  var value = mergedState[propertyKey];
                  var valid = void 0;

                  if (ruleKey == "_reducer") {
                    continue;
                  } else {
                    valid = this[ruleKey](value, rule);
                  }
                  if (!valid) {
                    this.properties[validation].valid = false;
                    propertyValidstate.valid = false;
                    propertyValidstate.reason = ruleKey;
                    propertyValidstate.message = this.getMessage(validation, propertyKey, ruleKey, rule);
                    break;
                  }
                }
              } catch (err) {
                _didIteratorError5 = true;
                _iteratorError5 = err;
              } finally {
                try {
                  if (!_iteratorNormalCompletion5 && _iterator5.return) {
                    _iterator5.return();
                  }
                } finally {
                  if (_didIteratorError5) {
                    throw _iteratorError5;
                  }
                }
              }
            }

            this.properties[validation][propertyKey] = _extends({}, propertyValidstate);
          }
        }
      } catch (err) {
        _didIteratorError4 = true;
        _iteratorError4 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion4 && _iterator4.return) {
            _iterator4.return();
          }
        } finally {
          if (_didIteratorError4) {
            throw _iteratorError4;
          }
        }
      }

      if (this.properties[validation].valid) {
        this.store.dispatch({
          type: ValidstateConst.VALIDSTATE_SUCCESS,
          payload: this.properties
        });
        return true;
      } else {
        this.store.dispatch({
          type: ValidstateConst.VALIDSTATE_FAIL,
          payload: this.properties
        });
        return false;
      }
    }

    /*
    * @function validateNestedProperties
    * @description Reads tree and validates nested properties
    * @param property, mergedState
    * @returns object
    */

  }, {
    key: 'validateNestedProperties',
    value: function validateNestedProperties(property, mergedState) {
      var propertyValidstate = {
        valid: true,
        reason: null,
        message: null
      };

      var _iteratorNormalCompletion6 = true;
      var _didIteratorError6 = false;
      var _iteratorError6 = undefined;

      try {
        for (var _iterator6 = Object.entries(property)[Symbol.iterator](), _step7; !(_iteratorNormalCompletion6 = (_step7 = _iterator6.next()).done); _iteratorNormalCompletion6 = true) {
          var _step7$value = _slicedToArray(_step7.value, 2),
              propertyKey = _step7$value[0],
              nextProp = _step7$value[1];

          if (propertyKey === "_reducer") {
            continue;
          } else if (this.depthOf(nextProp) > 1) {
            // Check top level property has children
            propertyValidstate[propertyKey] = this.validateNestedProperties(nextProp, mergedState[propertyKey]);
            if (propertyValidstate[propertyKey].valid == false) {
              propertyValidstate.valid = false;
            }
          } else {
            var _iteratorNormalCompletion7 = true;
            var _didIteratorError7 = false;
            var _iteratorError7 = undefined;

            try {
              for (var _iterator7 = Object.entries(property[propertyKey])[Symbol.iterator](), _step8; !(_iteratorNormalCompletion7 = (_step8 = _iterator7.next()).done); _iteratorNormalCompletion7 = true) {
                var _step8$value = _slicedToArray(_step8.value, 2),
                    ruleKey = _step8$value[0],
                    rule = _step8$value[1];

                propertyValidstate[propertyKey] = {
                  valid: true,
                  reason: null,
                  message: null
                };

                var value = mergedState[propertyKey];
                var valid = this[ruleKey](value, rule);
                if (!valid) {
                  propertyValidstate.valid = false;
                  propertyValidstate[propertyKey].valid = false;
                  propertyValidstate[propertyKey].reason = ruleKey;
                  // TODO add recursive method for child messages
                  // propertyValidstate[propertyKey].message = this.getMessage(validation, propertyKey, ruleKey, rule);
                  break;
                }
              }
            } catch (err) {
              _didIteratorError7 = true;
              _iteratorError7 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion7 && _iterator7.return) {
                  _iterator7.return();
                }
              } finally {
                if (_didIteratorError7) {
                  throw _iteratorError7;
                }
              }
            }
          }
        }
      } catch (err) {
        _didIteratorError6 = true;
        _iteratorError6 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion6 && _iterator6.return) {
            _iterator6.return();
          }
        } finally {
          if (_didIteratorError6) {
            throw _iteratorError6;
          }
        }
      }

      return propertyValidstate;
    }

    /*
    * @function clear
    * @description Clear validations
    * @param validation
    * @returns
    */

  }, {
    key: 'clear',
    value: function clear() {
      var validation = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

      if (validation == null) {
        this.store.dispatch({
          type: ValidstateConst.VALIDSTATE_CLEAR,
          payload: this.initialProperties
        });
      } else {
        this.store.dispatch({
          type: ValidstateConst.VALIDSTATE_CLEAR,
          payload: _defineProperty({}, validation, this.initialProperties[validation])
        });
      }
    }

    /*
    * @function getMessage
    * @description Retrive a user specified message or build a default message.
    * @param validation, propertyKey, ruleKey, value
    * @returns string
    */

  }, {
    key: 'getMessage',
    value: function getMessage(validation, propertyKey, ruleKey, rule) {
      if (this.messages[validation] !== undefined && this.messages[validation][propertyKey] !== undefined && this.messages[validation][propertyKey][ruleKey] !== undefined) {
        return this.messages[validation][propertyKey][ruleKey];
      } else {
        return this.messageTemplate[ruleKey](propertyKey, rule);
      }
    }

    /*
    * @function mergeState
    * @description Merge state into single object
    * @param state
    * @returns object
    */

  }, {
    key: 'mergeState',
    value: function mergeState(state) {
      var mergedState = {};
      var _iteratorNormalCompletion8 = true;
      var _didIteratorError8 = false;
      var _iteratorError8 = undefined;

      try {
        for (var _iterator8 = Object.entries(state)[Symbol.iterator](), _step9; !(_iteratorNormalCompletion8 = (_step9 = _iterator8.next()).done); _iteratorNormalCompletion8 = true) {
          var _step9$value = _slicedToArray(_step9.value, 2),
              key = _step9$value[0],
              reducer = _step9$value[1];

          if (key != "validstate") {
            mergedState = _extends({}, mergedState, reducer);
          }
        }
      } catch (err) {
        _didIteratorError8 = true;
        _iteratorError8 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion8 && _iterator8.return) {
            _iterator8.return();
          }
        } finally {
          if (_didIteratorError8) {
            throw _iteratorError8;
          }
        }
      }

      return mergedState;
    }

    /*
    * @function depthOf
    * @description Counts largest depth of object starting from 1
    * @param object
    * @returns integer
    */

  }, {
    key: 'depthOf',
    value: function depthOf(object) {
      var level = 1;
      var key = void 0;
      for (key in object) {
        if (!object.hasOwnProperty(key)) continue;

        if (_typeof(object[key]) == 'object') {
          var depth = this.depthOf(object[key]) + 1;
          level = Math.max(depth, level);
        }
      }
      return level;
    }

    /*
    * @function thetypeof
    * @description returns the type of supplied parameter. e.g(thetypeof(obj).is('object'))
    * @param value
    * @returns boolean
    */

  }, {
    key: 'thetypeof',
    value: function thetypeof(name) {
      var obj = {};
      obj.object = 'object Object';
      obj.array = 'object Array';
      obj.string = 'object String';
      obj.boolean = 'object Boolean';
      obj.number = 'object Number';
      obj.type = Object.prototype.toString.call(name).slice(1, -1);
      obj.name = Object.prototype.toString.call(name).slice(8, -1);
      obj.is = function (ofType) {
        ofType = ofType.toLowerCase();
        return obj.type === obj[ofType] ? true : false;
      };
      obj.isnt = function (ofType) {
        ofType = ofType.toLowerCase();
        return obj.type !== obj[ofType] ? true : false;
      };
      obj.error = function (ofType) {
        throw new TypeError('The type of ' + name + ' is ' + obj.name + ': ' + ('it should be of type ' + ofType));
      };
      return obj;
    }
  }, {
    key: 'getLength',


    /*
    * @function getLength
    * @description returns length of supplied value
    * @param value
    * @returns length
    */
    value: function getLength(value) {
      if (this.thetypeof(value).is('object')) {
        return Object.keys(value).length;
      } else {
        return value.length;
      }
    }

    /*
    * Checks if value is empty. Deep-checks arrays and objects
    * Note: isEmpty([]) == true, isEmpty({}) == true, isEmpty([{0:false},"",0]) == true, isEmpty({0:1}) == false
    * @param value
    * @returns {boolean}
    */

  }, {
    key: 'isEmpty',
    value: function isEmpty(value) {
      var _self = this;
      var isEmptyObject = function isEmptyObject(a) {
        if (typeof a.length === 'undefined') {
          // it's an Object, not an Array
          var hasNonempty = Object.keys(a).some(function nonEmpty(element) {
            return !_self.isEmpty(a[element]);
          });
          return hasNonempty ? false : isEmptyObject(Object.keys(a));
        }

        return !a.some(function nonEmpty(element) {
          // check if array is really not empty as JS thinks
          return !_self.isEmpty(element); // at least one element should be non-empty
        });
      };
      return value == false || typeof value === 'undefined' || value == null || (typeof value === 'undefined' ? 'undefined' : _typeof(value)) === 'object' && isEmptyObject(value) || Object.is(value, NaN);
    }

    /*
    * @function convertStringToArray
    * @description Takes a comma delimited string and converts to an array
    * @parameter string
    * @return Normalized array
    */

  }, {
    key: 'convertStringToArray',
    value: function convertStringToArray(string) {
      return string.toLowerCase().split(',').map(function (item) {
        return item.trim();
      });
    }

    /*
    * @function isPresent
    * @description Determine if a value is present
    * @parameter value
    * @return Boolean
    */

  }, {
    key: 'isPresent',
    value: function isPresent(value) {
      return !this.isEmpty(value);
    }

    /*
    * @function required
    * @description  Determine if a value is required
    * @parameter value
    * @return Boolean
    */

  }, {
    key: 'required',
    value: function required(value) {
      return this.isPresent(value);
    }

    /*
    * @function minLength
    * @description  Determine if a value's length is >= supplied length
    * @parameter value, length
    * @return Boolean
    */

  }, {
    key: 'minLength',
    value: function minLength(value, length) {
      return this.getLength(value) >= length ? true : false;
    }

    /*
    * @function maxLength
    * @description  Determine if a value's length is <= supplied length
    * @parameter value, length
    * @return Boolean
    */

  }, {
    key: 'maxLength',
    value: function maxLength(value, length) {
      return this.getLength(value) <= length ? true : false;
    }

    /*
    * @function rangeLength
    * @description Check value is between a given range of lengths.
    * @parameter value, range(hyphenated string)
    * @return Boolean
    */

  }, {
    key: 'rangeLength',
    value: function rangeLength(value, range) {
      if (this.thetypeof(value).is('array') || this.thetypeof(value).is('string')) {
        var rangeValue = range.split("-");
        return this.minLength(value, rangeValue[0]) && this.maxLength(value, rangeValue[1]);
      } else {
        return false;
      };
    }

    /*
    * @function min
    * @description  Determine if a value is >= min parameter
    * @parameter value, min
    * @return Boolean
    */

  }, {
    key: 'min',
    value: function min(value, _min) {
      return value >= _min ? true : false;
    }

    /*
    * @function max
    * @description  @description  Determine if a value is <= min parameter
    * @parameter value, max
    * @return Boolean
    */

  }, {
    key: 'max',
    value: function max(value, _max) {
      return value <= _max ? true : false;
    }

    /*
    * @function range
    * @description Check value is between a given range.
    * @parameter value, range(hyphenated string)
    * @return Boolean
    */

  }, {
    key: 'range',
    value: function range(value, _range) {
      var rangeValue = _range.split("-");
      return this.min(value, rangeValue[0]) && this.max(value, rangeValue[1]);
    }

    /*
    * @function step
    * @description Check value in given step.
    * @parameter value, step
    * @return Boolean
    */

  }, {
    key: 'step',
    value: function step(value, _step) {
      return value % _step !== 0 ? false : true;
    }

    /*
    * @function email
    * @description Check value is valid email.
    * @parameter email
    * @return Boolean
    */

  }, {
    key: 'email',
    value: function email(_email) {
      return (/^[a-zA-Z0-9.!#$%&'*+\/=?^_`{|}~-]+@[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)*$/.test(_email)
      );
    }

    /*
    * @function number
    * @description  Makes the element require a number.
    * @parameter value
    * @return Boolean
    */

  }, {
    key: 'number',
    value: function number(value) {
      return this.thetypeof(value).is('number') ? true : false;
    }

    /*
    * @function numeric
    * @description Makes the element require a numberical value.
    * @parameter value
    * @return Boolean
    */

  }, {
    key: 'numeric',
    value: function numeric(value) {
      if (this.thetypeof(value).is('number') || this.thetypeof(value).is('string')) {
        return !isNaN(parseFloat(value)) && isFinite(value);
      } else {
        return false;
      };
    }

    /*
    * @function integer
    * @description Checks for the value to be positive or negative non decimal.
    * @parameter value
    * @return Boolean
    */

  }, {
    key: 'integer',
    value: function integer(value) {
      if (this.thetypeof(value).is('number') || this.thetypeof(value).is('string')) {
        return Number.isInteger(value);
      }
    }

    /*
    * @function digits
    * @description Checks for the value to be positive non decimal numeral.
    * @parameter value
    * @return Boolean
    */

  }, {
    key: 'digits',
    value: function digits(value) {
      return (/^\d+$/.test(value)
      );
    }

    /*
    * @function equalTo
    * @description Soft compare of one value to another ==
    * @parameter value, comparison
    * @return Boolean
    */

  }, {
    key: 'equalTo',
    value: function equalTo(value, comparison) {
      return value == comparison;
    }

    /*
    * @function isEqualTo
    * @description Strong comparison of one value to another ===
    * @parameter value, comparison
    * @return Boolean
    */

  }, {
    key: 'isEqualTo',
    value: function isEqualTo(value, comparison) {
      return value === comparison;
    }

    /*
    * @function customFunction
    * @description evaluate user defined function
    * @parameter value, callback
    * @return Boolean
    */

  }, {
    key: 'custom',
    value: function custom(value, callback) {
      return callback(value);
    }

    /*
    * @function regex
    * @description Validates a valid regex status
    * @parameter value, regex
    * @return Boolean
    */

  }, {
    key: 'regex',
    value: function regex(value, _regex) {
      return _regex.test(value);
    }

    /*
    * @function creditCard
    * @description evaluates value and validates that it is a major credit card (Visa, MasterCard, Discover or Amex)
    * @parameter creditCardNumber
    * @return Boolean
    */

  }, {
    key: 'creditCard',
    value: function creditCard(creditCardNumber) {
      return (/^((4\d{3})|(5[1-5]\d{2})|(22\d{2})|(6011)|(34\d{1})|(37\d{1}))-?\s?\d{4}-?\s?\d{4}-?\s?\d{4}|3[4,7][\d\s-]{15,19}$/.test(creditCardNumber)
      );
    }

    /*
    * @function includes
    * @description Iterates over an array and checks if a given value is included
    * @parameter value, array
    * @return Boolean
    */

  }, {
    key: 'includes',
    value: function includes(value, str) {
      var array = this.convertStringToArray(str);
      return array.some(function (el) {
        return el === value;
      });
    }

    /*
    * @function excludes
    * @description Iterates over an array and checks if a given value is not included
    * @parameter value, array
    * @return Boolean
    */

  }, {
    key: 'excludes',
    value: function excludes(value, str) {
      var array = this.convertStringToArray(str);
      return array.every(function (el) {
        return el !== value.toLowerCase();
      });
    }

    /*
    * @function phone
    * @description evaluates value and validates that it is a valid american phone number
    * @parameter phoneNumber
    * @return Boolean
    */

  }, {
    key: 'phoneUS',
    value: function phoneUS(phoneNumber) {
      return (/^(?:\+?1[-\s]?)?\(?([2-9][0-8][0-9])\)?[-\s]?([2-9]\d{2})[-\s]?(\d{4})$/.test(phoneNumber)
      );
    }
  }]);

  return Validstate;
}();

exports.default = Validstate;