"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ValidstateMessages = function () {
  function ValidstateMessages() {
    _classCallCheck(this, ValidstateMessages);
  }

  _createClass(ValidstateMessages, [{
    key: "required",
    value: function required(property) {
      return this.titleCase(property) + " is required.";
    }
  }, {
    key: "minLength",
    value: function minLength(property, _minLength) {
      return this.titleCase(property) + " must be at least " + _minLength + " characters.";
    }
  }, {
    key: "maxLength",
    value: function maxLength(property, _maxLength) {
      return this.titleCase(property) + " can be no more than " + _maxLength + " characters.";
    }
  }, {
    key: "rangeLength",
    value: function rangeLength(property, rangeString) {
      var range = rangeString.split("-");
      return this.titleCase(property) + " must be between " + range[0] + " and " + range[1] + " characters.";
    }
  }, {
    key: "min",
    value: function min(property, _min) {
      return this.titleCase(property) + " must be greater than or equal to " + _min + ".";
    }
  }, {
    key: "max",
    value: function max(property, _max) {
      return this.titleCase(property) + " must be less than or equal to " + _max + ".";
    }
  }, {
    key: "range",
    value: function range(property, rangeString) {
      var range = rangeString.split("-");
      return this.titleCase(property) + " must be between " + range[0] + " and " + range[1] + ".";
    }
  }, {
    key: "step",
    value: function step(property, _step) {
      return this.titleCase(property) + " must be divisable by " + _step + ".";
    }
  }, {
    key: "email",
    value: function email(property) {
      return this.titleCase(property) + " must be formatted as an email.";
    }
  }, {
    key: "number",
    value: function number(property) {
      return this.titleCase(property) + " must be a number.";
    }
  }, {
    key: "numeric",
    value: function numeric(property) {
      return this.titleCase(property) + " must be a number.";
    }
  }, {
    key: "integer",
    value: function integer(property) {
      return this.titleCase(property) + " must be a integer.";
    }
  }, {
    key: "digits",
    value: function digits(property) {
      return this.titleCase(property) + " must be a whole number.";
    }
  }, {
    key: "equalTo",
    value: function equalTo(property, value) {
      return this.titleCase(property) + " must be equal to " + value + ".";
    }
  }, {
    key: "isEqualTo",
    value: function isEqualTo(property, value) {
      return this.titleCase(property) + " must be equal to " + value + ".";
    }
  }, {
    key: "custom",
    value: function custom(property, value) {
      return this.titleCase(property) + " is invalid.";
    }
  }, {
    key: "regex",
    value: function regex(property, value) {
      return this.titleCase(property) + " does not match '" + value + "'.";
    }
  }, {
    key: "creditCard",
    value: function creditCard(property) {
      return this.titleCase(property) + " is not a valid credit card.";
    }
  }, {
    key: "includes",
    value: function includes(property, value) {
      return this.titleCase(property) + " does not include " + value + ".";
    }
  }, {
    key: "phoneUS",
    value: function phoneUS(property) {
      return this.titleCase(property) + " is not a valid US phone number.";
    }
  }, {
    key: "titleCase",
    value: function titleCase(string) {
      var str = String(string);
      return str.split(' ').map(function (w) {
        return w[0].toUpperCase() + w.substr(1).toLowerCase();
      }).join(' ');
    }
  }]);

  return ValidstateMessages;
}();

exports.default = ValidstateMessages;